﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Threading;
using System.Globalization;

namespace howto_show_locale_dates
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // List the locales.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Make the ListBox use tabs.
            lstLocales.UseTabStops = true;
            lstLocales.UseCustomTabOffsets = true;

            // Define the tabs.
            ListBox.IntegerCollection offsets =
                lstLocales.CustomTabOffsets;
            offsets.Add(200);

            // Add the locale information.
            foreach (CultureInfo info in
                CultureInfo.GetCultures(CultureTypes.SpecificCultures))
                    lstLocales.Items.Add(new CultureData(info));
            
            // Select the first culture.
            lstLocales.SelectedIndex = 0;
        }

        // Display date and currency samples.
        private void lstLocales_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Get the selected culture's data.
            CultureData data = lstLocales.SelectedItem as CultureData;

            // Set the thread culture and UI culture.
            Thread.CurrentThread.CurrentUICulture = data.Info;
            Thread.CurrentThread.CurrentCulture = data.Info;

            // Display the date sample.
            // lblDate.Text = DateTime.Now.ToString("M/dd/yyyy");  // Bad. Custom specifier.
            lblDate.Text = DateTime.Now.ToString("D");  // Good. Standard specifier.

            // Display the date currency value.
            decimal value = 12345.67m;
            lblCurrency.Text = value.ToString("C");
        }
    }
}
